/*convolve.c*/
double 	 TWOPI, PI;
float  	 scalef;
int 	 scale;
long int lenin;
float   *sbuf1;
float   *tbuf1;
float   *filt1;
float   *sbuf2;
float   *tbuf2;
float   *filt2;
float   *dbuf1;
float   *dbuf2;
float	*delarray1,*delarray2;
#include "convolve.h"
#include "filefunc.c"
#include "convfunc.c"
#include "longfft.c"

/*#################################################################*/
/*#########################################################################
###########################---MAIN---######################################
###########################################################################*/
int main(int argv,char *argc[])
{
PI	=4.*atan(1.);
TWOPI	=2*PI ;


FOU	fou;
HEADER 	hed,hedh;
FILE 	*in,*out,*impulse;
float   duracion=0.,duracionh=0.,gain=0.,maxgain=0.,mix=0.,delay=0.,gaind=0.;
float   maxr=0., maxd=0.;
int 	delp1=0, delp2=0;
int     nargs=8, dels=0;/*exe, infile1, infile2,gainr,mode,gaind,delay,outfile*/
int 	eswav=0,esfou=0,stereo=1,mod=0;
long int N=0,N2=0,n=0,count=0,length=0;
int NCMAX=1048576;
long int icnt=0,ocnt=0;
long int clip=0,nwri=0;
/*#####################################*/
/*#####################################*/
/*pick up and check command line*/

if(argv<nargs)
	{fprintf(stderr,"WCONVOLVE.EXE: \n""NOT ENOUGH ARGUMENTS (%d)\n"
	"(infile1(.wav), infile2(.wav impulse response), \n gain, mod, gaindir, delay, outfile(*.wav)) \n\n"
	,argv-1);exit(-1);}
gain	=atof(argc[3]); /*gain for reverberation*/
mod		=atoi(argc[4]); /*whether convolution or deconvolution*/
gaind   =atof(argc[5]); /*gain for direct (infile)*/
delay	=atof(argc[6]); /*delay for reverberation*/
/*argc[1],[2] and [7] are infile, impulse response file, and outfile, respectively*/
label();
/*Here I attempt to trap the most common errors...*/
if(gain==0.)
	{fprintf(stderr,"WCONVOLVE.EXE: \n ERROR:gain of reverb can not be zero, use a delay line if you simply want to delay the direct...\n\n");
	 exit(-1);}
if(mod!=0 && mod!=1)
	{fprintf(stderr,"WCONVOLVE.EXE: \n ERROR: mode can only be 0(convolve) or 1 (deconvolve) what '%d' you want??? ...\n\n",mod);
	 exit(-1);}
if(delay<0.)
	{fprintf(stderr,"WCONVOLVE.EXE: \n ERROR: delay can not be a negative number (%f)...\n\n",delay);
	 exit(-1);}
if(delay>1.)
	{fprintf(stderr,"WCONVOLVE.EXE: \n WARNING: wow!!!...huge room (delay too large= %f)\n\n",delay);
	 }	 
/*******************************************/	
scale	=(int)pow(2.,15.);
scalef=1./scale;

fprintf(stderr,"\nINFILE:");
if((in=openwav(&hed,&duracion,LEER,STEREO,argc[1]))==NULL)
	{exit(-1);}
lenin=(long int)hed.datl/hed.ba;


fprintf(stderr,"\nIMPULSE RESPONSE FILE:");

/*must find out whether impulse is a wav or an fou file*/
if((impulse=fopen(argc[2],"rb"))==NULL)
	{fprintf(stderr,"\n CAN'T OPEN %s\n", argc[2]);
	exit(-1);}
what_is	(impulse,&eswav,&esfou);
fclose(impulse);
/***************************************/
/*now check file*/
if(eswav==1){
if((impulse=openwav(&hedh,&duracionh,LEER,STEREO,argc[2]))==NULL)
	{exit(-1);}
	}
if(esfou==1){
if((impulse=openfou(argc[2],&fou,LEER))==NULL)
	{exit(-1);}
	}
if(esfou!=1 && eswav!=1)
       { fprintf(stderr,"WCONVOLVE.EXE: \n ERROR: %s is neither WAV nor FOU file...\n\n",argc[2]);
	 exit(-1);}
/********open outfile(WAV)***************/
if((out=openwav(&hed,&duracion,ESCR,MONO,argc[7]))==NULL)
	{exit(-1);}
/********more errors may happen...******/
if(eswav==1){
	if(hedh.cha!=hed.cha)
		{fprintf(stderr,"\n ERROR=CHANNELS OF THE TWO INFILES MUST MATCH\n\n");exit(-1);}
	if(hedh.cha==2 || hed.cha==2)
	{stereo=2;}
}

if(esfou==1){
  if(fou.ncha!=hed.cha)
		{fprintf(stderr,"\n ERROR=CHANNELS OF THE TWO INFILES MUST MATCH\n\n");exit(-1);}
	if(fou.ncha==2 || hed.cha==2)
	{stereo=2;}
}
/*##########alocate memory for delay line#####################*/
if(delay!=0.)
	{
		dels=(int)(delay*(float)hed.SR);
	 	delarray1=(float *) aloca(dels*sizeof(float));	
		if(delarray1==NULL){
			closefile(in,out,impulse);
			exit(-1);}
		for(n=0;n<dels;++n) {delarray1[n]=0.;}
	if(hed.cha==2){
	 		delarray2=(float *) aloca(dels*sizeof(float));	
			if(delarray2==NULL){
			        free(delarray1);closefile(in,out,impulse);
				exit(-1);}
			for(n=0;n<dels;++n) {delarray2[n]=0.;}
		      }
	}
/*##########calculate and print main parameters#####################*/
if(eswav==1){
	length=(long int)(hedh.datl/hedh.ba);
	for(N2=2;N2<NCMAX; N2*=2){
		if(N2>=length) break;
		}
	N=2*N2;
	}
	else{
	N	=fou.dlen;
	N2	=N/2;
	length	=(long int)(fou.wlen/(2*fou.ncha));
	}
	
	fprintf(stderr,"\n FFT SIZE =  %ld\n",N/2);
	fprintf  (stderr," GAIN REV = %7.4f\n",gain);
	fprintf  (stderr," GAIN DIR = %7.4f\n",gaind);
	fprintf  (stderr," DEL  REV = %7.4f segs.\n",delay);
	fprintf  (stderr," MODE     = ");
	if(mod==0)fprintf  (stderr," CONVOLUTION\n");
	else		 fprintf  (stderr," DECONVOLUTION\n");
	fprintf  (stderr," RAM USED =  %ld K\n",(N2*20*stereo)/1024);

/*##########alocate memory for all buffers########################*/
/* oh, yes I know I could use an array of pointers
   but the FFT and IFFT programs I am using should be also modified, and I am not in the mood...are you?*/  
  
  if((sbuf1=(float *)aloca((size_t)(N+2)*sizeof(float)))==NULL){
		closefile(in,out,impulse);
		exit(-1);}
  if((tbuf1=(float *)aloca((size_t)N2*sizeof(float)))==NULL){
	        dealoc(stereo); closefile(in,out,impulse);
		exit(-1);}
  if((filt1=(float *)aloca((size_t)(N+2)*sizeof(float)))==NULL){
                dealoc(stereo);closefile(in,out,impulse);
		exit(-1);}
  if((dbuf1=(float *)aloca((size_t)(N+2)*sizeof(float)))==NULL){
		dealoc(stereo);closefile(in,out,impulse);
		exit(-1);}
  
  
  if(stereo==2){

			if((sbuf2=(float *)aloca((size_t)(N+2)*sizeof(float)))==NULL){
				dealoc(stereo);
				closefile(in,out,impulse);
				exit(-1);}
			if((tbuf2=(float *)aloca((size_t)N2*sizeof(float)))==NULL){
				dealoc(stereo);
			        closefile(in,out,impulse);
				exit(-1);}
			if((filt2=(float *)aloca((size_t)(N+2)*sizeof(float)))==NULL){
			        dealoc(stereo);
                                closefile(in,out,impulse);
				exit(-1);}
  			if((dbuf2=(float *)aloca((size_t)(N+2)*sizeof(float)))==NULL){
			        dealoc(stereo);
			        closefile(in,out,impulse);
  			        exit(-1);}
  }
/*#########read impulse response and perform FFT of it#####################*/
 if(eswav==1)	{
		readfile(length,impulse,filt1,filt2,hedh.cha);

		for(n=length;n<N+2;n++){
			filt1[n]=0.;
			if(stereo==2){filt2[n]=0.;}
			}
		
		fprintf(stderr,"\n FFT OF IMPULSE RESPONSE...");
		cfast(filt1,N);
		if(stereo==2){cfast(filt2,N);}
		fprintf(stderr,"O.K.\n\n");
 		}

 else		{
		readfou(N,impulse,filt1,filt2,fou.ncha);
		}
/*##########read first block of infile####################*/
	for(n=0;n<N2;n++){
		if(readfloat(in,sbuf1,n,&count)==0)
		{break;}
		dbuf1[n]=sbuf1[n];
	if(stereo==2){
		if(readfloat(in,sbuf2,n,&count)==0)
		{break;}
		dbuf2[n]=sbuf2[n];
		count-=1;
		}
	}
	icnt=n+(length-1);
	for(;n<N+2;n++){
		sbuf1[n]=dbuf1[n]=0.;
		if(stereo==2){sbuf2[n]=dbuf2[n]=0.;}

		}

/*############THIS IS THE MAIN PROCESSING LOOP##################*/
/*##############################################################*/
 while (ocnt<icnt){
			//fprintf(stderr," %ld samples written",ocnt);
			//fprintf(stderr," (FFT)");
	cfast(sbuf1,N);
	
	if(stereo==2)
		{cfast(sbuf2,N);}
								
	if (mod==0)
		{cmult(filt1,sbuf1,N2); /*fprintf(stderr,"(CMULT)")*/;}

	else
		{cdiv(filt1,sbuf1,N2); /*fprintf(stderr,"(CDIV)")*/;}


	if(stereo==2){
		if (mod==0)
			{cmult(filt2,sbuf2,N2);}
		else
		   	{cdiv(filt2,sbuf2,N2);}
		     }
	
	//fprintf(stderr,"(IFFT)");
	
	cfsst(sbuf1,N);
	
	if(stereo==2)
		{cfsst(sbuf2,N);}

	for(n=0;n<N2;n++){
		
		tbuf1[n]+= sbuf1[n];
		
		if(stereo==2){tbuf2[n]+= sbuf2[n];}
		}
	
	for(n=0;n<N2;n++){
		
		if(++ocnt<=icnt){
			
			if(delay!=0.)
				{
				mix=fdelay(gain*tbuf1[n],delarray1,&delp1,dels)+(gaind*dbuf1[n]);
				}	 
			else	{	
				mix=(gain*tbuf1[n])+(gaind*dbuf1[n]);
				}
			writefloat(out,mix,&nwri,&maxgain,&clip);
			        	if(fabs((double)tbuf1[n])>maxr)
	                        	{maxr=(float)fabs((double)tbuf1[n]);}
			
			if(stereo==2){
				
				if(delay!=0.)
				{
				mix=fdelay(gain*tbuf2[n],delarray2,&delp2,dels)+(gaind*dbuf2[n]);
				}	 
			else	{	
				mix=(gain*tbuf2[n])+(gaind*dbuf2[n]);
				}
				writefloat(out,mix,&nwri,&maxgain,&clip);
			        	if(fabs((double)tbuf2[n])>maxr)
	                        	{maxr=(float)fabs((double)tbuf2[n]);}  
				nwri-=1;
			}				
		}
	}

	for(n=0;n<N2;n++){
		tbuf1[n] = sbuf1[N2+n];
		if(stereo==2)
			{tbuf2[n] = sbuf2[N2+n];}
		}


   	for(n=0;n<N2;n++){
		if(readfloat(in,sbuf1,n,&count)==0)
		     {break;}
	        dbuf1[n]=sbuf1[n];
		if(stereo==2){
		  if(readfloat(in,sbuf2,n,&count)==0)
	             {break;} 
		  dbuf2[n]=sbuf2[n];
		  count-=1;
		}
	}
	icnt+=n;
	for(;n<N+2;n++){
		sbuf1[n]=dbuf1[n]=0.;
		if(stereo==2){sbuf2[n]=dbuf2[n]=0.;}
		}
//fprintf(stderr,"\r");		
}
//fprintf(stderr,"\r                                                             ");

/*if there is a non-zero delay, we must keep flushing samples until the  delay is done...*/
if(delay!=0.){
	for(n=0;n<dels;++n){
		mix=fdelay(gain*tbuf1[n],delarray1,&delp1,dels);	
		writefloat(out,mix,&nwri,&maxgain,&clip);
			if(fabs((double)tbuf1[n])>maxr)
	                {maxr=(float)fabs((double)tbuf1[n]);}
		if(stereo==2){
			mix=fdelay(gain*tbuf2[n],delarray2,&delp2,dels);
			writefloat(out,mix,&nwri,&maxgain,&clip);
				if(fabs((double)tbuf2[n])>maxr)
	                        {maxr=(float)fabs((double)tbuf1[n]);}
			nwri-=1;
		}
	
	}
	

}

/*#################PROCESS IS DONE###########################*/
fprintf(stderr,"\n %lu samples written on %s",nwri*stereo,argc[7]);

fprintf(stderr,"\n maxgain(rev+dir)= %8.4f",maxgain);
if(clip!=0){fprintf(stderr,"(%lu samples out of range...)",clip);}
fprintf(stderr,"\n maxgain(rev)    = %8.4f",maxr*gain);

maxd=(float)(maxgain-(maxr*gain));
fprintf(stderr,"\n maxgain(dir)    = %8.4f",maxd);

/*######Update outfile header###############################*/
	nwri=nwri*hed.ba;
	fseek(out,40,SEEK_SET);fwrite(&nwri,4,1,out);
	nwri=nwri+36;
	fseek(out,4,SEEK_SET);fwrite(&nwri,4,1,out);
/*######Free memory and close files#########################*/
        dealoc(stereo);
	closefile(in,out,impulse);
fprintf(stderr,"\n DONE...!!!");
return 0;
}
