#include <stdio.h>
#include <math.h>
//#include<conio.h>
#include<stdlib.h>
//#include<ctype.h>


typedef struct {
  double mag;
  double ang;
}polar;

double PI;

/*****************************************************************/
/*****************************************************************/
int main(int argc,char *argv[])
{
  int i,M=0,N=0,pu=0,j=0;
  int maxarg=0,np=1,nc=1,flc=1,flp=1;
  polar *zero;
  polar *pole;
  polar *acoef;
  polar *bcoef;
  double *resflt;
  double omin=0.,omax=PI,ostep=(omax-omin)/441., omega,gain=1.,amp,num,den;
  double amax=0,frec=0;

  /*##########################################################*/
  void 	getcoef	       (polar *coef,polar *root,int Nroots,int M,int N);
  polar *cnegmult      (polar *a,polar *b);
  polar *cadd          (polar a,polar b);
  int 	 par	       (int num);
  void   label         ();
  int    writeflt      (int N,int M,polar *zero, polar *pole,polar *acoef,polar *bcoef,
			double amax,double *resflt);
  double length        (double omega, polar point);
  /*##########################################################*/

  PI=4.*atan(1.);

  if(argc<3)
    {printf("\nPOLZER EXE: numero insuficiente de argumentos...(%d) \n",argc-1);
      return -1;}
  M=atoi(argv[1]);
  if(M>6)
    {printf("\nPOLZER EXE: ERROR, max. ceros=6...");
      return -1;}

  if(par(M))
    {flc=0;}
  nc=((M+flc)/2)*2;
  pu=nc+2;
  if(argc<pu)
    {printf("\nPOLZER EXE: numero insuficiente de argumentos...(%d)",argc-1);
      return -1;}

  N=atoi(argv[pu]);
  if(N>6)
    {printf("\nPOLZER EXE: ERROR, max. polos=6...");
      return -1;}
  if(par(N))
    {flc=0;}
  np=((N+flc)/2)*2;
  maxarg=nc+np+3;

  if(argc < maxarg)
    {printf("\nPOLZER EXE: numero insuficiente de argumentos...(%d)"
	    ,argc-1);
      return -1;}
  /*##########################################################*/
  /*##########################################################*/
  label();
  resflt=(double*)malloc(3536*sizeof(double));
  zero= (polar*)malloc(12*sizeof(polar));
  pole=(polar*)malloc(12*sizeof(polar));
  acoef=(polar*)malloc(12*sizeof(polar));
  bcoef=(polar*)malloc(12*sizeof(polar));

  /*##########################################################*/
  printf("\nNUMERO DE CEROS= %d",M);
  for(i=1;i<M+1;i+=2){

    zero[i].mag=(double)atof(argv[i+1]);
    zero[i].ang=(double)atof(argv[i+2])*PI;
    printf("\n  CERO%d, magnitud= %5.4f  ",i,zero[i].mag);
    printf("angulo  = %5.4f",atof(argv[i+2]));
    printf("(%5.1lf Hz)",atof(argv[i+2])*22050);
    if(M==1)break;
    zero[i+1].mag=zero[i].mag; /*conjugada compleja*/
    zero[i+1].ang=-zero[i].ang;
    printf("\n  CERO%d, magnitud= %5.4f  ",i+1,zero[i+1].mag);
    if(-atof(argv[i+2])>=0){printf(" ");}
    printf("angulo  =%5.4f",-atof(argv[i+2]));
  }
  printf("\nNUMERO DE POLOS= %d",N);
  for(i=pu+1;i<N+1+pu;i+=2){

    pole[i-pu].mag=(double)atof(argv[i]);
    pole[i-pu].ang=(double)atof(argv[i+1])*PI;
    printf("\n  POLO%d, magnitud= %5.4f  ",i-pu,pole[i-pu].mag);
    printf("angulo  = %5.4f",atof(argv[i+1]));
    printf("(%5.1lf Hz)",atof(argv[i+1])*22050);
    if(N==1)break;
    pole[(i+1)-pu].mag=pole[i-pu].mag; /*conjugada compleja*/
    pole[(i+1)-pu].ang=-pole[i-pu].ang;
    printf("\n  POLO%d, magnitud= %5.4f  ",(i+1)-pu,pole[(i+1)-pu].mag);
    if(-atof(argv[i+1])>=0){printf(" ");}
    printf("angulo  =%5.4f",-atof(argv[i+1]));
  }


  /************ENCONTRAR E IMPRIMIR COEFICIENTES*********************/
  getcoef(acoef,zero,M,M,N);
  getcoef(bcoef,pole,N,M,N);
  printf("\n\nCOEFICIENTES PARA EL FILTRO = \n");
  for(i=1;i<=M;i++){
    if(acoef[i].mag !=0.)
      printf("a%d=%lf ",i,acoef[i].mag);
  }
  printf("\n");
  for(i=1;i<=N;i++){
    if(bcoef[i].mag !=0.)
      printf("b%d=%lf ",i,bcoef[i].mag);
  }
  /************CALCULAR RESPUESTA A FRECUENCIA*********************/
  printf("\ncalculando respuesta a frecuencia...");
  for(omega=omin;omega<=omax+ostep;omega+=ostep){ 
    j++;
    num=den=1.;
    for( i=0; i<=M; i++){
      num *=length(omega,zero[i]);}
    for(i=0; i<=N; i++){
      den *=length(omega,pole[i]);}
    num *=gain;
    if(den !=0.)
      {amp=num/den; resflt[j]=amp;}
    else{printf("\n%6.0fHz= FILTRO INESTABLE (division por cero)",(22050./PI)*omega); resflt[j]=amp=HUGE_VAL;}
    if(amp>amax){amax=amp;frec=(22050./PI)*omega;}
  }

  /************GRABAR ARCHIVO Y TERMINAR*********************/
  printf("\nmaximo valor de respuesta = %lf en los %8.3lfHz",amax,frec);
  writeflt(N,M,zero,pole,acoef,bcoef,amax,resflt);
  printf("\nLISTO...!!!");  
  free(resflt);
  free(zero);
  free(pole);
  free(acoef);
  free(bcoef);
  return 0;
}
/*****************************************************************/
/*****************************************************************/
polar *cadd		(polar *a,polar *b)
{
  static polar *v;
  double x,y;
  /*convertir de polar a rectangular*/
  x=a->mag*cos(a->ang);
  y=a->mag*sin(a->ang);
  x+=b->mag*cos(b->ang);
  y+=b->mag*sin(b->ang);
  v->mag=sqrt(x*x+y*y);
  v->ang=atan2(y,x);
  if(fabs(fabs(v->ang)-PI)<1.e-6){
    v->mag=-v->mag;
    v->ang=0.;
  }
  return(v);
}
/*****************************************************************/
polar *cnegmult(polar a,polar b)
{
  static polar *v;
  v->mag=-a.mag*b.mag;
  v->ang=a.ang+b.ang;
  if(fabs(fabs(v->ang)-PI)<1.e-6){
    v->mag=-v->mag;
    v->ang=0.;
  }
  return(v);
}
/*****************************************************************/

void 	getcoef(polar *coef,polar *root,int Nroots,int M,int N)
{
  int i,j;

  for(i=0;i<=N;i++){
    coef[i].mag=coef[i].ang=0.;}
  coef[0].mag=1.;

  for(i=1;i<=Nroots;i++){
    coef[i]=cnegmult(root[i],coef[i-1]);
    for(j=i-1;j>=1;j--)
      coef[j]=cadd(coef[j],cnegmult(root[i],coef[j-1]));
  }
  return;
}
/*****************************************************************/
int  par	(int num)
{
  int test=num%2;

  switch (test){
  case 0:
    return(1);
	
  default:
    return(0);
  }
  return(-1);
}
/*#######################################################################*/
void label()
{
  printf("ANALISIS DE FILTROS DIGITALES\n");
  printf("UNQUI, MUSICA ELECTROACUSTICA,");
  printf\
    (" COMPUTACION APLICADA A LA MUSICA \nProf. Oscar Pablo Di Liscia ");
  printf("ULTIMA VERSION: 5/11/95\n");
  return;
}
/*#######################################################################*/
int    writeflt  (int N,int M,polar *zero,polar *pole,polar *acoef,polar *bcoef,double amax,double  *resflt)

{
  FILE *flt;
  double aux;
  int i,bywri=0;

  if ((flt=fopen("\\filtro.flt", "wb"))==NULL)
    {printf("\nERROR-NO PUEDO ABRIR EL ARCHIVO INDICADO\n");
      return(0);}
  printf("\nESCRIBIENDO EN 'FILTRO.FLT'...");

  fwrite(&M,1,2,flt);        /*CEROS*/
  bywri+=2;
  for(i=1;i<=M;i++){
    aux=zero[i].mag;
    fwrite(&aux,1,8,flt);
    aux=zero[i].ang;
    fwrite(&aux,1,8,flt);
    bywri+=16;
  }
  fwrite(&N,1,2,flt);     	/*POLOS*/
  bywri+=2;
  for(i=1;i<=N;i++){
    aux=pole[i].mag;
    fwrite(&aux,1,8,flt);
    aux=pole[i].ang;
    fwrite(&aux,1,8,flt);
    bywri+=16;
  }
  for(i=1;i<=M;i++){        /*ACOEF*/
    aux=acoef[i].mag;
    fwrite(&aux,1,8,flt);
    bywri+=8;}
  for(i=1;i<=N;i++){
    aux=bcoef[i].mag;     /*BCOEF*/
    fwrite(&aux,1,8,flt);
    bywri+=8;}
  fwrite(&amax,1,8,flt);    /*MAXIMA RESPUESTA DE FREC*/ 
  bywri+=8;
  for(i=0;i<441;i++){
    aux=resflt[i];        /*441 valores de respuesta de frecuencia*/
    fwrite(&aux,1,8,flt);
    bywri+=8;}
  fclose(flt);printf("(%d bytes escritos)",bywri);
  return(1);
}
/*#######################################################################*/
double length   (double omega, polar point)
{
  double a,b;
  a=point.mag*cos(point.ang)-cos(omega);
  b=point.mag*sin(point.ang)-sin(omega);
  return(sqrt(a*a + b*b));
}

