#include "../sndlib-l/io.c"
#include "../sndlib-l/headers.c"
#include "../sndlib-l/sound.c"
#include "../my_funcs/io_funcs.h"
#include "sndiag.h"

#define RMS_BLOCK_SIZE .05 /*Length of the block for RMS in secs.*/

int main(int argc, char *argv[])
{
  SOUND_DATA *in_data;
  CHANNEL_DATA *c_data;
  int i;
  mus_sample_t **bufs;
  long int RMSblock;

  if(checkin(argc, 2, "Command line: sndiag filename", "SNDIAG")==-1) {
    getchar();
    return(-1);
  }

  mus_sound_initialize();	
  if((in_data=open_input(argv[1],  "\nINPUT FILE:"))==NULL)
    {return(-1);}
  
  /*RESERVAR MEMORIA*/
  bufs=snd_memalloc(in_data, BUFFER_SIZE);
  c_data=(CHANNEL_DATA*)malloc(in_data->chans*sizeof(CHANNEL_DATA));

  /*INICIALIZAR VARIABLES*/
  RMSblock=(long int)((float)in_data->srate*RMS_BLOCK_SIZE);

  /*ANALIZAR*/
  do_analysis(in_data, c_data, bufs, RMSblock);
  
  /*IMPRIMIR INFORME*/
  print_report(in_data, c_data);
  
  /*LIBERAR MEMORIA, CERRAR ARCHIVOS*/
  snd_dealloc(in_data, BUFFER_SIZE, bufs);
  close(in_data->fd);
  free(in_data);
  free(c_data);
  return(0);
}



